//same as onebit_bitbang06 but uses arpeggio
//buttons sets the speed
//knob sets arpeggio range

//speaker + 6 buttons (pins 2-7) + knob (analog input 0)

int outPin= 9;  //speaker output pwm9
int ain= 0;     //knob input analog 0

int del;
int freq[]= {167, 218, 30, 144, 255, 251, 181, 241, 183, 67, 26, 119, 184, 184, 102, 2};
//int freq[]= {250, 200, 50, 50, 100, 250, 200, 200, 150, 50, 100, 250, 50, 150, 200, 200};
//int freq[]= {5, 175, 175, 5, 25, 175, 125, 75, 250, 175, 100, 5, 5, 175, 5, 5};
int index= 0;
int jndex= 0;

void setup() {
  pinMode(outPin, OUTPUT);   //speaker pin as output
  DDRD= DDRD|B11111100;      //pins 2-7 as inputs
  PORTD= B11111100;          //activate internal pullup
}

void loop() {
  int range= analogRead(ain);
  int fre= freq[index%jndex];
  index= (index+1)%(sizeof(freq)/sizeof(int));
  if(index==4) {
    jndex= (jndex+1)%(sizeof(freq)/sizeof(int));
  }
  del= (PIND>>2+1)*12;        //speed from buttons
  
  //--arpeggio
  del= del/3;
  for(int i= 0; i<del; i++) {
    digitalWrite(outPin, HIGH);
    delayMicroseconds(fre);
    digitalWrite(outPin, LOW);
    delayMicroseconds(fre);
  }
  fre= fre+range;
  for(int i= 0; i<del; i++) {
    digitalWrite(outPin, HIGH);
    delayMicroseconds(fre);
    digitalWrite(outPin, LOW);
    delayMicroseconds(fre);
  }
  fre= fre+range;
  for(int i= 0; i<del; i++) {
    digitalWrite(outPin, HIGH);
    delayMicroseconds(fre);
    digitalWrite(outPin, LOW);
    delayMicroseconds(fre);
  }
}
