//more pwm misuse

//speaker + 6 buttons (pins 2-7) + knob

int outPin= 9;  //speaker output pwm9
int knobPin= 0; //analog input

int i;
int freq;
int scale;
int cnt= 42;

void setup() {
  DDRD= DDRD|B11111100;      //pins 2-7 as inputs
  PORTD= B11111100;          //activate internal pullup
  
  TCCR1A= B11110010;     //timer setup (see meg8 datasheet table39)
  TCCR1B= B00011001;     //try changing the 3 last bits (see meg8 datasheet table40)
  ICR1= 255;             //set counter maximum - sort of base freq
  DDRB= (1<<1);          //same as pinMode(outPin, OUTPUT);
}

void loop() {
  
  for(i= 10; i<=cnt; i++) {
    
    //--buttons and knob inputs
    scale= analogRead(knobPin);
    freq= PIND>>2;            //mask bits/pins 0 and 1
    freq= (freq*scale)%255;   //map buttons for freq and scale with knob
    ICR1= freq;
    OCR1A= freq*i%255;              //same as analogWrite(outPin, i);
  }
  cnt++;
}
