//music for battery, chip and speaker

int outPin= 9;  //speaker output pwm9
//no button or knob inputs

int i;
int freq;
int scale;
int del= 25;
int cnt= 42;
int index= 0;
char dataS[]= "A A A A AAAAA A AAAAA A A A A A  A+A+dkdkdkdk01000100dkdkdkdk A A@@@@!!!! dkdkdkdk A A@@@@!!!! dkdkdkdk";
char dataF[]= "f f k . f f p . f f k . f f p+++ ZZZZdkdkdkdkdkdkdkdddkdkdkdk++++O2O3O2O3 dkdkdkdk++++O2O3O2O3 dkdkdkdk";

void setup() {
  TCCR1A= B11110010;     //timer setup (see meg8 datasheet table39)
  TCCR1B= B00011001;     //try changing the 3 last bits (see meg8 datasheet table40)
  ICR1= 255;             //set counter maximum - sort of base freq
  DDRB= (1<<1);          //same as pinMode(outPin, OUTPUT);
}

void loop() {
  scale= dataS[index];
  freq= dataF[index];
  freq= (freq*scale)%255;   //map buttons for freq and scale with knob
  ICR1= freq;
  for(i= 10; i<=cnt; i++) {
    OCR1A= freq*i%255;
    delay(del);
  }
  index= index+1;
  if(index==(sizeof(dataS)/sizeof(char))) {
    delay(2000);    //wait a little and then restart
    index= 0;
  }
}
