//tiny rules create complexity
//buttons selects rules

//speaker + 6 buttons (pins 2-7)

int outPin= 9;  //speaker output pwm9

int fre= 300;
int dur= 30;
int index= 0;

void setup() {
  pinMode(outPin, OUTPUT);   //speaker pin as output
  DDRD= DDRD|B11111100;      //pins 2-7 as inputs
  PORTD= B11111100;          //activate internal pullup
}

void loop() {
  
  //--rules
  switch(index) {
    case 0:
      fre= fre+1;
      break;
    case 1:
      fre= fre-1;
      break;
    case 2:
      dur= dur-4;
      index= index+1;
      break;
    case 3:
      dur= dur+1;
      break;
    case 4:
      fre= fre*2;
      dur= dur+1;
      break;
    case 5:
      index= fre;
      break;
    case 6:
      dur= fre;
      index= index+1;
      break;
    case 7:
      index= index-2;
      break;
    case 8:
      fre= dur*2;
      break;
  }
  index= (index+1)%PIND;
  fre= abs(fre)%255;
  dur= abs(dur)%255;
  
  for(int i= 0; i<dur; i++) {
    digitalWrite(outPin, HIGH);
    delayMicroseconds(fre);
    digitalWrite(outPin, LOW);
    delayMicroseconds(fre);
  }
}
