//similar example but setting registers explicitly
//ie not using arduino's built in function
//now we can do other base frequencies

//slow lfo changing pulse width

int outPin= 9;  //speaker output pwm9

int i;          //lfo counter
int freq= 40;   //lfo freq

void setup() {
  TCCR1A= B11110010;     //timer setup (see meg8 datasheet table39)
  TCCR1B= B00011101;     //try changing the 3 last bits (see meg8 datasheet table40)
  ICR1= 150;             //set counter maximum - sort of base freq
  DDRB= (1<<1);          //same as pinMode(outPin, OUTPUT);
}
void loop() {
   for(i= 0 ; i<=255; i++) {
    OCR1A= i;            //same as analogWrite(outPin, i);
    delay(freq);
  }
}
